/* ----------------------------------------------------------------------------
 * Copyright (c) Huawei Technologies Co., Ltd. 2013-2020. All rights reserved.
 * Description: ShellCmd Cpup
 * Author: Huawei LiteOS Team
 * Create: 2013-01-01
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright notice, this list of
 * conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice, this list
 * of conditions and the following disclaimer in the documentation and/or other materials
 * provided with the distribution.
 * 3. Neither the name of the copyright holder nor the names of its contributors may be used
 * to endorse or promote products derived from this software without specific prior written
 * permission.
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --------------------------------------------------------------------------- */

#include "los_config.h"
#ifdef LOSCFG_SHELL
#include "stdio.h"
#include "stdlib.h"
#include "los_cpup_pri.h"
#include "los_task_pri.h"
#include "shcmd.h"
#include "shell.h"

#ifdef __cplusplus
#if __cplusplus
extern "C" {
#endif /* __cplusplus */
#endif /* __cplusplus */

VOID OsCmdCpupOperateOneParam(UINT32 mode)         //根据参数mode获取系统CPU使用率的历史数据//
{
    UINT32 ret;

    if (mode == CPUP_LAST_TEN_SECONDS) {            //过去10s内//
        PRINTK("\nSysCpuUsage in 10s: ");
    } else if (mode == CPUP_LAST_ONE_SECONDS) {     //过去1s内//
        PRINTK("\nSysCpuUsage in 1s: ");   
    } else {                                        //历史平均CPU使用率//
        PRINTK("\nSysCpuUsage in all time: ");
    }
    ret = LOS_HistorySysCpuUsage(mode);             //获取CPU使用率的数值//
    PRINTK("%u.%u", ret / LOS_CPUP_PRECISION_MULT, ret % LOS_CPUP_PRECISION_MULT);
}

VOID OsCmdCpupOperateTwoParam(UINT32 mode, UINT32 taskId)    //根据参数mode获取参数taskId所指定//
{                                                            //的任务的CPU使用率的历史数据//
    UINT32 ret;

    if (mode == CPUP_LAST_TEN_SECONDS) {            //过去10s内//
        PRINTK("\nTaskId %u CpuUsage in 10s: ", taskId);
    } else if (mode == CPUP_LAST_ONE_SECONDS) {     //过去1s内//
        PRINTK("\nTaskId %u CpuUsage in 1s: ", taskId);
    } else {                                        //历史平均CPU使用率//
        PRINTK("\nTaskId %u CpuUsage in all time: ", taskId);
    }
    ret = LOS_HistoryTaskCpuUsage(taskId, mode);             //获取CPU使用率的数值//
    PRINTK("%u.%u", ret / LOS_CPUP_PRECISION_MULT, ret % LOS_CPUP_PRECISION_MULT);
}

LITE_OS_SEC_TEXT_MINOR UINT32 OsShellCmdCpup(INT32 argc, const CHAR **argv) //根据输入的参数来获取系统或指定任务的CPU使用率//
{
    size_t mode, taskId;
    CHAR *bufMode = NULL;
    CHAR *bufId = NULL;
    LosTaskCB *taskCB = NULL;
    UINT32 ret;

    if (argc <= 0) {        //检查参数个数，如果没有参数，则获取系统过去10秒的CPU使用率并打印输出//
        ret = LOS_HistorySysCpuUsage(CPUP_LAST_TEN_SECONDS);
        PRINTK("\nSysCpuUsage in 10s: %u.%u", ret / LOS_CPUP_PRECISION_MULT, ret % LOS_CPUP_PRECISION_MULT);
        return 0;
    }

    mode = strtoul(argv[0], &bufMode, 0);   //将第一个参数转换为无符号整型数mode，表示CPU使用率的获取模式//
/*------------------------------------------------------------------*/
    //判断输入的mode是否有效//
    if ((bufMode == NULL) || (*bufMode != 0)) {
        PRINTK("\nThe input mode is invalid. Please try again.\n");
        return 0;
    }

    if (mode > CPUP_ALL_TIME) {
        mode = CPUP_ALL_TIME;
    }
/*------------------------------------------------------------------*/
//如果只有一个参数，则调用OsCmdCpupOperateOneParam函数来获取系统CPU使用率//
    if (argc == 1) {
        OsCmdCpupOperateOneParam((UINT32)mode);
        return 0;
    }
/*------------------------------------------------------------------*/
//判断输入的taskId是否有效//
    taskId = strtoul(argv[1], &bufId, 0);
    if ((taskId >= g_taskMaxNum) || (*bufId != 0)) {
        PRINTK("\nThe input taskId is invalid. Please try again.\n");
        return 0;
    }
    taskCB = OS_TCB_FROM_TID(taskId);
    if (taskCB->taskStatus & OS_TASK_STATUS_UNUSED) {
        PRINTK("\nThe task is unused. Please try again.\n");
        return 0;
    }
/*-----------------------------------------------------------------*/
//如果有两个参数，则第二个参数为任务ID，然后调用OsCmdCpupOperateTwoParam函数来获取指定任务的CPU使用率//
    if (argc == 2) {
        OsCmdCpupOperateTwoParam((UINT32)mode, (UINT32)taskId);
        return 0;
    }

    PRINTK("cpup [MODE] \ncpup [MODE] [TASKID] \n");
    return 0;
}
//通过在Shell终端输入cpup命令，根据输入相应的参数来获取CPU使用率的历史数据//
SHELLCMD_ENTRY(cpup_shellcmd, CMD_TYPE_EX, "cpup", XARGS, (CmdCallBackFunc)OsShellCmdCpup);
#ifdef __cplusplus
#if __cplusplus
}
#endif /* __cplusplus */
#endif /* __cplusplus */
#endif /* LOSCFG_SHELL */
